# This file was auto-generated by Fern from our API Definition.

import typing_extensions
import typing_extensions
import typing
from .bank_account_created_event_data import BankAccountCreatedEventDataParams


class BankAccountCreatedEventParams(typing_extensions.TypedDict):
    """
    Published when you link an external bank account to a Square
    account in the Seller Dashboard. Square sets the initial status to
    `VERIFICATION_IN_PROGRESS` and publishes the event.
    """

    merchant_id: typing_extensions.NotRequired[typing.Optional[str]]
    """
    The ID of the target merchant associated with the event.
    """

    location_id: typing_extensions.NotRequired[typing.Optional[str]]
    """
    The ID of the target location associated with the event.
    """

    type: typing_extensions.NotRequired[typing.Optional[str]]
    """
    The type of event this represents, `"bank_account.created"`.
    """

    event_id: typing_extensions.NotRequired[typing.Optional[str]]
    """
    A unique ID for the event.
    """

    created_at: typing_extensions.NotRequired[str]
    """
    Timestamp of when the event was created, in RFC 3339 format.
    """

    data: typing_extensions.NotRequired[BankAccountCreatedEventDataParams]
    """
    Data associated with the event.
    """
