# This file was auto-generated by Fern from our API Definition.

import typing_extensions
import typing_extensions
import typing
from .custom_attribute_definition_event_data import CustomAttributeDefinitionEventDataParams


class BookingCustomAttributeDefinitionVisibleDeletedEventParams(typing_extensions.TypedDict):
    """
    Published when a booking [custom attribute definition](entity:CustomAttributeDefinition)
    with the `visibility` field set to `VISIBILITY_READ_ONLY` or `VISIBILITY_READ_WRITE_VALUES` is deleted.
    An application that subscribes to this event is notified when a booking custom attribute definition is deleted
    by any application for which the subscribing application has read access to the booking custom attribute definition.
    """

    merchant_id: typing_extensions.NotRequired[typing.Optional[str]]
    """
    The ID of the seller associated with the event that triggered the event notification.
    """

    type: typing_extensions.NotRequired[typing.Optional[str]]
    """
    The type of this event. The value is `"booking.custom_attribute_definition.visible.deleted"`.
    """

    event_id: typing_extensions.NotRequired[typing.Optional[str]]
    """
    A unique ID for the event notification.
    """

    created_at: typing_extensions.NotRequired[str]
    """
    The timestamp that indicates when the event notification was created, in RFC 3339 format.
    """

    data: typing_extensions.NotRequired[CustomAttributeDefinitionEventDataParams]
    """
    The data associated with the event that triggered the event notification.
    """
