# This file was auto-generated by Fern from our API Definition.

import typing_extensions
import typing_extensions
import typing


class BreakParams(typing_extensions.TypedDict):
    """
    A record of a team member's break on a [timecard](entity:Timecard).
    """

    id: typing_extensions.NotRequired[str]
    """
    The UUID for this object.
    """

    start_at: str
    """
    RFC 3339; follows the same timezone information as the [timecard](entity:Timecard). Precision up to
    the minute is respected; seconds are truncated.
    """

    end_at: typing_extensions.NotRequired[typing.Optional[str]]
    """
    RFC 3339; follows the same timezone information as the [timecard](entity:Timecard). Precision up to
    the minute is respected; seconds are truncated.
    """

    break_type_id: str
    """
    The [BreakType](entity:BreakType) that this break was templated on.
    """

    name: str
    """
    A human-readable name.
    """

    expected_duration: str
    """
    Format: RFC-3339 P[n]Y[n]M[n]DT[n]H[n]M[n]S. The expected length of
    the break.
    
    Example for break expected duration of 15 minutes: PT15M
    """

    is_paid: bool
    """
    Whether this break counts towards time worked for compensation
    purposes.
    """
