# This file was auto-generated by Fern from our API Definition.

import typing_extensions
import typing_extensions
import typing
from .create_customer_response import CreateCustomerResponseParams
from .error import ErrorParams


class BulkCreateCustomersResponseParams(typing_extensions.TypedDict):
    """
    Defines the fields included in the response body from the
    [BulkCreateCustomers](api-endpoint:Customers-BulkCreateCustomers) endpoint.
    """

    responses: typing_extensions.NotRequired[typing.Dict[str, CreateCustomerResponseParams]]
    """
    A map of responses that correspond to individual create requests, represented by
    key-value pairs.
    
    Each key is the idempotency key that was provided for a create request and each value
    is the corresponding response.
    If the request succeeds, the value is the new customer profile.
    If the request fails, the value contains any errors that occurred during the request.
    """

    errors: typing_extensions.NotRequired[typing.Sequence[ErrorParams]]
    """
    Any top-level errors that prevented the bulk operation from running.
    """
