# This file was auto-generated by Fern from our API Definition.

import typing_extensions
from .custom_attribute import CustomAttributeParams
import typing_extensions
import typing


class BulkUpsertOrderCustomAttributesRequestUpsertCustomAttributeParams(typing_extensions.TypedDict):
    """
    Represents one upsert within the bulk operation.
    """

    custom_attribute: CustomAttributeParams
    """
    The custom attribute to create or update, with the following fields:
    
    - `value`. This value must conform to the `schema` specified by the definition. 
    For more information, see [Value data types](https://developer.squareup.com/docs/customer-custom-attributes-api/custom-attributes#value-data-types).
    
    - `version`. To enable [optimistic concurrency](https://developer.squareup.com/docs/build-basics/common-api-patterns/optimistic-concurrency)
    control, include this optional field and specify the current version of the custom attribute.
    """

    idempotency_key: typing_extensions.NotRequired[typing.Optional[str]]
    """
    A unique identifier for this request, used to ensure idempotency. 
    For more information, see [Idempotency](https://developer.squareup.com/docs/build-basics/common-api-patterns/idempotency).
    """

    order_id: str
    """
    The ID of the target [order](entity:Order).
    """
