# This file was auto-generated by Fern from our API Definition.

import typing_extensions
import typing_extensions
from ..types.cash_drawer_event_type import CashDrawerEventType
from .money import MoneyParams
import typing


class CashDrawerShiftEventParams(typing_extensions.TypedDict):
    id: typing_extensions.NotRequired[str]
    """
    The unique ID of the event.
    """

    event_type: typing_extensions.NotRequired[CashDrawerEventType]
    """
    The type of cash drawer shift event.
    See [CashDrawerEventType](#type-cashdrawereventtype) for possible values
    """

    event_money: typing_extensions.NotRequired[MoneyParams]
    """
    The amount of money that was added to or removed from the cash drawer
    in the event. The amount can be positive (for added money)
    or zero (for other tender type payments). The addition or removal of money can be determined by
    by the event type.
    """

    created_at: typing_extensions.NotRequired[str]
    """
    The event time in RFC 3339 format.
    """

    description: typing_extensions.NotRequired[typing.Optional[str]]
    """
    An optional description of the event, entered by the employee that
    created the event.
    """

    team_member_id: typing_extensions.NotRequired[str]
    """
    The ID of the team member that created the event.
    """
