# This file was auto-generated by Fern from our API Definition.

from __future__ import annotations
import typing_extensions
import typing_extensions
import typing
from ..types.catalog_category_type import CatalogCategoryType
from .catalog_ecom_seo_data import CatalogEcomSeoDataParams
from .category_path_to_root_node import CategoryPathToRootNodeParams
import typing

if typing.TYPE_CHECKING:
    from .catalog_object_category import CatalogObjectCategoryParams


class CatalogCategoryParams(typing_extensions.TypedDict):
    """
    A category to which a `CatalogItem` instance belongs.
    """

    name: typing_extensions.NotRequired[typing.Optional[str]]
    """
    The category name. This is a searchable attribute for use in applicable query filters, and its value length is of Unicode code points.
    """

    image_ids: typing_extensions.NotRequired[typing.Optional[typing.Sequence[str]]]
    """
    The IDs of images associated with this `CatalogCategory` instance.
    Currently these images are not displayed by Square, but are free to be displayed in 3rd party applications.
    """

    category_type: typing_extensions.NotRequired[CatalogCategoryType]
    """
    The type of the category.
    See [CatalogCategoryType](#type-catalogcategorytype) for possible values
    """

    parent_category: typing_extensions.NotRequired["CatalogObjectCategoryParams"]
    """
    The ID of the parent category of this category instance.
    """

    is_top_level: typing_extensions.NotRequired[typing.Optional[bool]]
    """
    Indicates whether a category is a top level category, which does not have any parent_category.
    """

    channels: typing_extensions.NotRequired[typing.Optional[typing.Sequence[str]]]
    """
    A list of IDs representing channels, such as a Square Online site, where the category can be made visible.
    """

    availability_period_ids: typing_extensions.NotRequired[typing.Optional[typing.Sequence[str]]]
    """
    The IDs of the `CatalogAvailabilityPeriod` objects associated with the category.
    """

    online_visibility: typing_extensions.NotRequired[typing.Optional[bool]]
    """
    Indicates whether the category is visible (`true`) or hidden (`false`) on all of the seller's Square Online sites.
    """

    root_category: typing_extensions.NotRequired[str]
    """
    The top-level category in a category hierarchy.
    """

    ecom_seo_data: typing_extensions.NotRequired[CatalogEcomSeoDataParams]
    """
    The SEO data for a seller's Square Online store.
    """

    path_to_root: typing_extensions.NotRequired[typing.Optional[typing.Sequence[CategoryPathToRootNodeParams]]]
    """
    The path from the category to its root category. The first node of the path is the parent of the category
    and the last is the root category. The path is empty if the category is a root category.
    """
