# This file was auto-generated by Fern from our API Definition.

import typing_extensions
import typing_extensions
import typing
from .catalog_modifier_override import CatalogModifierOverrideParams


class CatalogItemModifierListInfoParams(typing_extensions.TypedDict):
    """
    Controls how a modifier list is applied to a specific item. This object allows for item-specific customization of modifier list behavior
    and provides the ability to override global modifier list settings.
    """

    modifier_list_id: str
    """
    The ID of the `CatalogModifierList` controlled by this `CatalogModifierListInfo`.
    """

    modifier_overrides: typing_extensions.NotRequired[typing.Optional[typing.Sequence[CatalogModifierOverrideParams]]]
    """
    A set of `CatalogModifierOverride` objects that override default modifier settings for this item.
    """

    min_selected_modifiers: typing_extensions.NotRequired[typing.Optional[int]]
    """
    The minimum number of modifiers that must be selected from this modifier list.
    Values:
    
    - 0: No selection is required.
    - -1: Default value, the attribute was not set by the client. When `max_selected_modifiers` is
    also -1, use the minimum and maximum selection values set on the `CatalogItemModifierList`.
    - &gt;0: The required minimum modifier selections. This can be larger than the total `CatalogModifiers` when `allow_quantities` is enabled.
    - &lt; -1: Invalid. Treated as no selection required.
    """

    max_selected_modifiers: typing_extensions.NotRequired[typing.Optional[int]]
    """
    The maximum number of modifiers that can be selected.
    Values:
    
    - 0: No maximum limit.
    - -1: Default value, the attribute was not set by the client. When `min_selected_modifiers` is
    also -1, use the minimum and maximum selection values set on the `CatalogItemModifierList`.
    - &gt;0: The maximum total modifier selections. This can be larger than the total `CatalogModifiers` when `allow_quantities` is enabled.
    - &lt; -1: Invalid. Treated as no maximum limit.
    """

    enabled: typing_extensions.NotRequired[typing.Optional[bool]]
    """
    If `true`, enable this `CatalogModifierList`. The default value is `true`.
    """

    ordinal: typing_extensions.NotRequired[typing.Optional[int]]
    """
    The position of this `CatalogItemModifierListInfo` object within the `modifier_list_info` list applied 
    to a `CatalogItem` instance.
    """

    allow_quantities: typing_extensions.NotRequired[typing.Optional[typing.Any]]
    is_conversational: typing_extensions.NotRequired[typing.Optional[typing.Any]]
    hidden_from_customer_override: typing_extensions.NotRequired[typing.Optional[typing.Any]]
