# This file was auto-generated by Fern from our API Definition.

import typing_extensions
import typing_extensions
import typing
from ..types.customer_creation_source import CustomerCreationSource
from ..types.customer_inclusion_exclusion import CustomerInclusionExclusion


class CustomerCreationSourceFilterParams(typing_extensions.TypedDict):
    """
    The creation source filter.

    If one or more creation sources are set, customer profiles are included in,
    or excluded from, the result if they match at least one of the filter criteria.
    """

    values: typing_extensions.NotRequired[typing.Optional[typing.Sequence[CustomerCreationSource]]]
    """
    The list of creation sources used as filtering criteria.
    See [CustomerCreationSource](#type-customercreationsource) for possible values
    """

    rule: typing_extensions.NotRequired[CustomerInclusionExclusion]
    """
    Indicates whether a customer profile matching the filter criteria
    should be included in the result or excluded from the result.
    
    Default: `INCLUDE`.
    See [CustomerInclusionExclusion](#type-customerinclusionexclusion) for possible values
    """
