# This file was auto-generated by Fern from our API Definition.

import typing_extensions
import typing_extensions
import typing
from .custom_attribute_event_data import CustomAttributeEventDataParams


class CustomerCustomAttributeUpdatedEventParams(typing_extensions.TypedDict):
    """
    Published when a customer [custom attribute](entity:CustomAttribute) owned by the
    subscribing application is created or updated. Custom attributes are owned by the application that created
    the corresponding [custom attribute definition](entity:CustomAttributeDefinition). Custom attributes whose
    `visibility` is `VISIBILITY_READ_WRITE_VALUES` can be created or updated by any application.

    This event is replaced by
    [customer.custom_attribute.owned.updated](webhook:customer.custom_attribute.owned.updated).
    """

    merchant_id: typing_extensions.NotRequired[typing.Optional[str]]
    """
    The ID of the seller associated with the event that triggered the event notification.
    """

    type: typing_extensions.NotRequired[typing.Optional[str]]
    """
    The type of this event. The value is `"customer.custom_attribute.updated"`.
    """

    event_id: typing_extensions.NotRequired[typing.Optional[str]]
    """
    A unique ID for the event notification.
    """

    created_at: typing_extensions.NotRequired[str]
    """
    The timestamp that indicates when the event notification was created, in RFC 3339 format.
    """

    data: typing_extensions.NotRequired[CustomAttributeEventDataParams]
    """
    The data associated with the event that triggered the event notification.
    """
