# This file was auto-generated by Fern from our API Definition.

import typing_extensions
import typing_extensions
import typing
from .custom_attribute_event_data import CustomAttributeEventDataParams


class CustomerCustomAttributeVisibleUpdatedEventParams(typing_extensions.TypedDict):
    """
    Published when a customer [custom attribute](entity:CustomAttribute) that is visible to the
    subscribing application is created or updated. A notification is sent when:
    - Your application creates or updates a custom attribute owned by your application, regardless of the `visibility` setting.
    - Any application creates or updates a custom attribute whose `visibility` is `VISIBILITY_READ_ONLY`
    or `VISIBILITY_READ_WRITE_VALUES`.

    Custom attributes set to `VISIBILITY_READ_WRITE_VALUES` can be created or updated by any application, but those set to
    `VISIBILITY_READ_ONLY` or `VISIBILITY_HIDDEN` can only be created or updated by the owner. Custom attributes are owned
    by the application that created the corresponding [custom attribute definition](entity:CustomAttributeDefinition).
    """

    merchant_id: typing_extensions.NotRequired[typing.Optional[str]]
    """
    The ID of the seller associated with the event that triggered the event notification.
    """

    type: typing_extensions.NotRequired[typing.Optional[str]]
    """
    The type of this event. The value is `"customer.custom_attribute.visible.updated"`.
    """

    event_id: typing_extensions.NotRequired[typing.Optional[str]]
    """
    A unique ID for the event notification.
    """

    created_at: typing_extensions.NotRequired[str]
    """
    The timestamp that indicates when the event notification was created, in RFC 3339 format.
    """

    data: typing_extensions.NotRequired[CustomAttributeEventDataParams]
    """
    The data associated with the event that triggered the event notification.
    """
