# This file was auto-generated by Fern from our API Definition.

import typing_extensions
import typing_extensions
import typing


class CustomerTextFilterParams(typing_extensions.TypedDict):
    """
    A filter to select customers based on exact or fuzzy matching of
    customer attributes against a specified query. Depending on the customer attributes,
    the filter can be case-sensitive. This filter can be exact or fuzzy, but it cannot be both.
    """

    exact: typing_extensions.NotRequired[typing.Optional[str]]
    """
    Use the exact filter to select customers whose attributes match exactly the specified query.
    """

    fuzzy: typing_extensions.NotRequired[typing.Optional[str]]
    """
    Use the fuzzy filter to select customers whose attributes match the specified query 
    in a fuzzy manner. When the fuzzy option is used, search queries are tokenized, and then 
    each query token must be matched somewhere in the searched attribute. For single token queries, 
    this is effectively the same behavior as a partial match operation.
    """
