# This file was auto-generated by Fern from our API Definition.

import typing_extensions
import typing_extensions
import typing
from .customer_updated_event_data import CustomerUpdatedEventDataParams


class CustomerUpdatedEventParams(typing_extensions.TypedDict):
    """
    Published when a [customer](entity:Customer) is updated. For more information, see [Use Customer Webhooks](https://developer.squareup.com/docs/customers-api/use-the-api/customer-webhooks).

    Updates to the 'segment_ids' customer field does not invoke a `customer.updated` event. In addition, the `customer` object in the event notification does not include this field.
    """

    merchant_id: typing_extensions.NotRequired[typing.Optional[str]]
    """
    The ID of the seller associated with the event.
    """

    type: typing_extensions.NotRequired[typing.Optional[str]]
    """
    The type of event. For this object, the value is `customer.updated`.
    """

    event_id: typing_extensions.NotRequired[typing.Optional[str]]
    """
    The unique ID of the event, which is used for [idempotency support](https://developer.squareup.com/docs/webhooks/step4manage#webhooks-best-practices).
    """

    created_at: typing_extensions.NotRequired[str]
    """
    The timestamp of when the event was created, in RFC 3339 format.
    """

    data: typing_extensions.NotRequired[CustomerUpdatedEventDataParams]
    """
    The data associated with the event.
    """
