# This file was auto-generated by Fern from our API Definition.

import typing_extensions
import typing_extensions
import typing
from .dispute_evidence_added_event_data import DisputeEvidenceAddedEventDataParams


class DisputeEvidenceAddedEventParams(typing_extensions.TypedDict):
    """
    Published when evidence is added to a [Dispute](entity:Dispute)
    from the Disputes Dashboard in the Seller Dashboard, the Square Point of Sale app,
    or by calling either [CreateDisputeEvidenceFile](api-endpoint:Disputes-CreateDisputeEvidenceFile) or [CreateDisputeEvidenceText](api-endpoint:Disputes-CreateDisputeEvidenceText).
    """

    merchant_id: typing_extensions.NotRequired[typing.Optional[str]]
    """
    The ID of the target merchant associated with the event.
    """

    location_id: typing_extensions.NotRequired[typing.Optional[str]]
    """
    The ID of the target location associated with the event.
    """

    type: typing_extensions.NotRequired[typing.Optional[str]]
    """
    The type of event this represents.
    """

    event_id: typing_extensions.NotRequired[typing.Optional[str]]
    """
    A unique ID for the event.
    """

    created_at: typing_extensions.NotRequired[str]
    """
    Timestamp of when the event was created, in RFC 3339 format.
    """

    data: typing_extensions.NotRequired[DisputeEvidenceAddedEventDataParams]
    """
    Data associated with the event.
    """
