# This file was auto-generated by Fern from our API Definition.

import typing_extensions
import typing_extensions
import typing
from .dispute_state_updated_event_data import DisputeStateUpdatedEventDataParams


class DisputeStateUpdatedEventParams(typing_extensions.TypedDict):
    """
    Published when the state of a [Dispute](entity:Dispute) changes.
    This includes the dispute resolution (WON, LOST) reported by the bank. The event
    data includes details of what changed.
    """

    merchant_id: typing_extensions.NotRequired[typing.Optional[str]]
    """
    The ID of the target merchant associated with the event.
    """

    location_id: typing_extensions.NotRequired[typing.Optional[str]]
    """
    The ID of the target location associated with the event.
    """

    type: typing_extensions.NotRequired[typing.Optional[str]]
    """
    The type of event this represents.
    """

    event_id: typing_extensions.NotRequired[typing.Optional[str]]
    """
    A unique ID for the event.
    """

    created_at: typing_extensions.NotRequired[str]
    """
    Timestamp of when the event was created, in RFC 3339 format.
    """

    data: typing_extensions.NotRequired[DisputeStateUpdatedEventDataParams]
    """
    Data associated with the event.
    """
