# This file was auto-generated by Fern from our API Definition.

import typing_extensions
import typing_extensions
import typing
from .money import MoneyParams


class GiftCardActivityRefundParams(typing_extensions.TypedDict):
    """
    Represents details about a `REFUND` [gift card activity type](entity:GiftCardActivityType).
    """

    redeem_activity_id: typing_extensions.NotRequired[typing.Optional[str]]
    """
    The ID of the refunded `REDEEM` gift card activity. Square populates this field if the 
    `payment_id` in the corresponding [RefundPayment](api-endpoint:Refunds-RefundPayment) request 
    represents a gift card redemption.
    
    For applications that use a custom payment processing system, this field is required when creating
    a `REFUND` activity. The provided `REDEEM` activity ID must be linked to the same gift card.
    """

    amount_money: typing_extensions.NotRequired[MoneyParams]
    """
    The amount added to the gift card for the refund. This value is a positive integer.
    
    This field is required when creating a `REFUND` activity. The amount can represent a full or partial refund.
    """

    reference_id: typing_extensions.NotRequired[typing.Optional[str]]
    """
    A client-specified ID that associates the gift card activity with an entity in another system.
    """

    payment_id: typing_extensions.NotRequired[str]
    """
    The ID of the refunded payment. Square populates this field if the refund is for a 
    payment processed by Square. This field matches the `payment_id` in the corresponding
    [RefundPayment](api-endpoint:Refunds-RefundPayment) request.
    """
