# This file was auto-generated by Fern from our API Definition.

import typing_extensions
import typing_extensions
import typing
from .gift_card_activity_updated_event_data import GiftCardActivityUpdatedEventDataParams


class GiftCardActivityUpdatedEventParams(typing_extensions.TypedDict):
    """
    Published when a [gift card activity](entity:GiftCardActivity) is updated.
    Subscribe to this event to be notified about the following changes:
    - An update to the `REDEEM` activity for a gift card redemption made from a Square product (such as Square Point of Sale).
    These redemptions are initially assigned a `PENDING` state, but then change to a `COMPLETED` or `CANCELED` state.
    - An update to the `IMPORT` activity for an imported gift card when the balance is later adjusted by Square.
    """

    merchant_id: typing_extensions.NotRequired[typing.Optional[str]]
    """
    The ID of the Square seller associated with the event.
    """

    type: typing_extensions.NotRequired[typing.Optional[str]]
    """
    The type of event. For this event, the value is `gift_card.activity.updated`.
    """

    event_id: typing_extensions.NotRequired[typing.Optional[str]]
    """
    The unique ID of the event, which is used for 
    [idempotency support](https://developer.squareup.com/docs/webhooks/step4manage#webhooks-best-practices).
    """

    created_at: typing_extensions.NotRequired[str]
    """
    The timestamp of when the event was created, in RFC 3339 format.
    """

    data: typing_extensions.NotRequired[GiftCardActivityUpdatedEventDataParams]
    """
    The data associated with the event.
    """
