# This file was auto-generated by Fern from our API Definition.

import typing_extensions
import typing_extensions
import typing
from .gift_card_customer_linked_event_data import GiftCardCustomerLinkedEventDataParams


class GiftCardCustomerLinkedEventParams(typing_extensions.TypedDict):
    """
    Published when a [customer](entity:Customer) is linked to a [gift card](entity:GiftCard).
    """

    merchant_id: typing_extensions.NotRequired[typing.Optional[str]]
    """
    The ID of the Square seller associated with the event.
    """

    type: typing_extensions.NotRequired[typing.Optional[str]]
    """
    The type of event. For this event, the value is `gift_card.customer_linked`.
    """

    event_id: typing_extensions.NotRequired[typing.Optional[str]]
    """
    The unique ID of the event, which is used for 
    [idempotency support](https://developer.squareup.com/docs/webhooks/step4manage#webhooks-best-practices).
    """

    created_at: typing_extensions.NotRequired[str]
    """
    The timestamp of when the event was created, in RFC 3339 format.
    """

    data: typing_extensions.NotRequired[GiftCardCustomerLinkedEventDataParams]
    """
    The data associated with the event.
    """
