# This file was auto-generated by Fern from our API Definition.

import typing_extensions
import typing_extensions
import typing
from ..types.inventory_state import InventoryState
from .source_application import SourceApplicationParams


class InventoryPhysicalCountParams(typing_extensions.TypedDict):
    """
    Represents the quantity of an item variation that is physically present
    at a specific location, verified by a seller or a seller's employee. For example,
    a physical count might come from an employee counting the item variations on
    hand or from syncing with an external system.
    """

    id: typing_extensions.NotRequired[str]
    """
    A unique Square-generated ID for the
    [InventoryPhysicalCount](entity:InventoryPhysicalCount).
    """

    reference_id: typing_extensions.NotRequired[typing.Optional[str]]
    """
    An optional ID provided by the application to tie the
    [InventoryPhysicalCount](entity:InventoryPhysicalCount) to an external
    system.
    """

    catalog_object_id: typing_extensions.NotRequired[typing.Optional[str]]
    """
    The Square-generated ID of the
    [CatalogObject](entity:CatalogObject) being tracked.
    """

    catalog_object_type: typing_extensions.NotRequired[typing.Optional[str]]
    """
    The [type](entity:CatalogObjectType) of the [CatalogObject](entity:CatalogObject) being tracked. 
    
    The Inventory API supports setting and reading the `"catalog_object_type": "ITEM_VARIATION"` field value. 
    In addition, it can also read the `"catalog_object_type": "ITEM"` field value that is set by the Square Restaurants app.
    """

    state: typing_extensions.NotRequired[InventoryState]
    """
    The current [inventory state](entity:InventoryState) for the related
    quantity of items.
    See [InventoryState](#type-inventorystate) for possible values
    """

    location_id: typing_extensions.NotRequired[typing.Optional[str]]
    """
    The Square-generated ID of the [Location](entity:Location) where the related
    quantity of items is being tracked.
    """

    quantity: typing_extensions.NotRequired[typing.Optional[str]]
    """
    The number of items affected by the physical count as a decimal string.
    The number can support up to 5 digits after the decimal point.
    """

    source: typing_extensions.NotRequired[SourceApplicationParams]
    """
    Information about the application with which the
    physical count is submitted.
    """

    employee_id: typing_extensions.NotRequired[typing.Optional[str]]
    """
    The Square-generated ID of the [Employee](entity:Employee) responsible for the
    physical count.
    """

    team_member_id: typing_extensions.NotRequired[typing.Optional[str]]
    """
    The Square-generated ID of the [Team Member](entity:TeamMember) responsible for the
    physical count.
    """

    occurred_at: typing_extensions.NotRequired[typing.Optional[str]]
    """
    A client-generated RFC 3339-formatted timestamp that indicates when
    the physical count was examined. For physical count updates, the `occurred_at`
    timestamp cannot be older than 24 hours or in the future relative to the
    time of the request.
    """

    created_at: typing_extensions.NotRequired[str]
    """
    An RFC 3339-formatted timestamp that indicates when the physical count is received.
    """
