# This file was auto-generated by Fern from our API Definition.

import typing_extensions
import typing_extensions
import typing
from .invoice_payment_made_event_data import InvoicePaymentMadeEventDataParams


class InvoicePaymentMadeEventParams(typing_extensions.TypedDict):
    """
    Published when a payment that is associated with an [invoice](entity:Invoice) is completed.
    For more information about invoice payments, see [Pay an invoice](https://developer.squareup.com/docs/invoices-api/pay-refund-invoices#pay-invoice).
    """

    merchant_id: typing_extensions.NotRequired[typing.Optional[str]]
    """
    The ID of the target merchant associated with the event.
    """

    type: typing_extensions.NotRequired[typing.Optional[str]]
    """
    The type of event this represents, `"invoice.payment_made"`.
    """

    event_id: typing_extensions.NotRequired[typing.Optional[str]]
    """
    A unique ID for the event.
    """

    created_at: typing_extensions.NotRequired[str]
    """
    Timestamp of when the event was created, in RFC 3339 format.
    """

    data: typing_extensions.NotRequired[InvoicePaymentMadeEventDataParams]
    """
    Data associated with the event.
    """
