# This file was auto-generated by Fern from our API Definition.

import typing_extensions
import typing_extensions
import typing
from .invoice_refunded_event_data import InvoiceRefundedEventDataParams


class InvoiceRefundedEventParams(typing_extensions.TypedDict):
    """
    Published when a refund is applied toward a payment of an [invoice](entity:Invoice).
    For more information about invoice refunds, see [Refund an invoice](https://developer.squareup.com/docs/invoices-api/pay-refund-invoices#refund-invoice).
    """

    merchant_id: typing_extensions.NotRequired[typing.Optional[str]]
    """
    The ID of the target merchant associated with the event.
    """

    type: typing_extensions.NotRequired[typing.Optional[str]]
    """
    The type of event this represents, `"invoice.refunded"`.
    """

    event_id: typing_extensions.NotRequired[typing.Optional[str]]
    """
    A unique ID for the event.
    """

    created_at: typing_extensions.NotRequired[str]
    """
    Timestamp of when the event was created, in RFC 3339 format.
    """

    data: typing_extensions.NotRequired[InvoiceRefundedEventDataParams]
    """
    Data associated with the event.
    """
