# This file was auto-generated by Fern from our API Definition.

import typing_extensions
import typing_extensions
import typing


class JobParams(typing_extensions.TypedDict):
    """
    Represents a job that can be assigned to [team members](entity:TeamMember). This object defines the
    job's title and tip eligibility. Compensation is defined in a [job assignment](entity:JobAssignment)
    in a team member's wage setting.
    """

    id: typing_extensions.NotRequired[str]
    """
    **Read only** The unique Square-assigned ID of the job. If you need a job ID for an API request,
    call [ListJobs](api-endpoint:Team-ListJobs) or use the ID returned when you created the job.
    You can also get job IDs from a team member's wage setting.
    """

    title: typing_extensions.NotRequired[typing.Optional[str]]
    """
    The title of the job.
    """

    is_tip_eligible: typing_extensions.NotRequired[typing.Optional[bool]]
    """
    Indicates whether team members can earn tips for the job.
    """

    created_at: typing_extensions.NotRequired[str]
    """
    The timestamp when the job was created, in RFC 3339 format.
    """

    updated_at: typing_extensions.NotRequired[str]
    """
    The timestamp when the job was last updated, in RFC 3339 format.
    """

    version: typing_extensions.NotRequired[int]
    """
    **Read only** The current version of the job. Include this field in `UpdateJob` requests to enable
    [optimistic concurrency](https://developer.squareup.com/docs/working-with-apis/optimistic-concurrency)
    control and avoid overwrites from concurrent requests. Requests fail if the provided version doesn't
    match the server version at the time of the request.
    """
