# This file was auto-generated by Fern from our API Definition.

import typing_extensions
import typing_extensions
import typing
from .custom_attribute import CustomAttributeParams
from .error import ErrorParams


class ListLocationCustomAttributesResponseParams(typing_extensions.TypedDict):
    """
    Represents a [ListLocationCustomAttributes](api-endpoint:LocationCustomAttributes-ListLocationCustomAttributes) response.
    Either `custom_attributes`, an empty object, or `errors` is present in the response. If additional
    results are available, the `cursor` field is also present along with `custom_attributes`.
    """

    custom_attributes: typing_extensions.NotRequired[typing.Sequence[CustomAttributeParams]]
    """
    The retrieved custom attributes. If `with_definitions` was set to `true` in the request,
    the custom attribute definition is returned in the `definition` field of each custom attribute.
    If no custom attributes are found, Square returns an empty object (`{}`).
    """

    cursor: typing_extensions.NotRequired[str]
    """
    The cursor to use in your next call to this endpoint to retrieve the next page of results
    for your original request. This field is present only if the request succeeded and additional
    results are available. For more information, see [Pagination](https://developer.squareup.com/docs/build-basics/common-api-patterns/pagination).
    """

    errors: typing_extensions.NotRequired[typing.Sequence[ErrorParams]]
    """
    Any errors that occurred during the request.
    """
