# This file was auto-generated by Fern from our API Definition.

import typing_extensions
import typing_extensions
import typing
from .custom_attribute_definition_event_data import CustomAttributeDefinitionEventDataParams


class LocationCustomAttributeDefinitionOwnedUpdatedEventParams(typing_extensions.TypedDict):
    """
    Published when a location [custom attribute definition](entity:CustomAttributeDefinition)
    created by the subscribing application is updated. A custom attribute definition can only be updated
    by the application that created it.
    """

    merchant_id: typing_extensions.NotRequired[typing.Optional[str]]
    """
    The ID of the seller associated with the event that triggered the event notification.
    """

    type: typing_extensions.NotRequired[typing.Optional[str]]
    """
    The type of this event. The value is `"location.custom_attribute_definition.owned.updated"`.
    """

    event_id: typing_extensions.NotRequired[typing.Optional[str]]
    """
    A unique ID for the event notification.
    """

    created_at: typing_extensions.NotRequired[str]
    """
    The timestamp that indicates when the event notification was created, in RFC 3339 format.
    """

    data: typing_extensions.NotRequired[CustomAttributeDefinitionEventDataParams]
    """
    The data associated with the event that triggered the event notification.
    """
