# This file was auto-generated by Fern from our API Definition.

import typing_extensions
import typing_extensions
import typing
from ..types.country import Country
from ..types.currency import Currency
from ..types.merchant_status import MerchantStatus


class MerchantParams(typing_extensions.TypedDict):
    """
    Represents a business that sells with Square.
    """

    id: typing_extensions.NotRequired[str]
    """
    The Square-issued ID of the merchant.
    """

    business_name: typing_extensions.NotRequired[typing.Optional[str]]
    """
    The name of the merchant's overall business.
    """

    country: Country
    """
    The country code associated with the merchant, in the two-letter format of ISO 3166. For example, `US` or `JP`.
    See [Country](#type-country) for possible values
    """

    language_code: typing_extensions.NotRequired[typing.Optional[str]]
    """
    The code indicating the [language preferences](https://developer.squareup.com/docs/build-basics/general-considerations/language-preferences) of the merchant, in [BCP 47 format](https://tools.ietf.org/html/bcp47#appendix-A). For example, `en-US` or `fr-CA`.
    """

    currency: typing_extensions.NotRequired[Currency]
    """
    The currency associated with the merchant, in ISO 4217 format. For example, the currency code for US dollars is `USD`.
    See [Currency](#type-currency) for possible values
    """

    status: typing_extensions.NotRequired[MerchantStatus]
    """
    The merchant's status.
    See [MerchantStatus](#type-merchantstatus) for possible values
    """

    main_location_id: typing_extensions.NotRequired[typing.Optional[str]]
    """
    The ID of the [main `Location`](https://developer.squareup.com/docs/locations-api#about-the-main-location) for this merchant.
    """

    created_at: typing_extensions.NotRequired[str]
    """
    The time when the merchant was created, in RFC 3339 format.
       For more information, see [Working with Dates](https://developer.squareup.com/docs/build-basics/working-with-dates).
    """
