# This file was auto-generated by Fern from our API Definition.

import typing_extensions
import typing_extensions
import typing
from .custom_attribute_event_data import CustomAttributeEventDataParams


class MerchantCustomAttributeOwnedUpdatedEventParams(typing_extensions.TypedDict):
    """
    Published when a merchant [custom attribute](entity:CustomAttribute)
    associated with a [custom attribute definition](entity:CustomAttributeDefinition) that is
    owned by the subscribing application is updated. Subscribe to this event to be notified
    when your application updates a merchant custom attribute.
    """

    merchant_id: typing_extensions.NotRequired[typing.Optional[str]]
    """
    The ID of the seller associated with the event that triggered the event notification.
    """

    type: typing_extensions.NotRequired[typing.Optional[str]]
    """
    The type of this event. The value is `"merchant.custom_attribute.owned.updated"`.
    """

    event_id: typing_extensions.NotRequired[typing.Optional[str]]
    """
    A unique ID for the event notification.
    """

    created_at: typing_extensions.NotRequired[str]
    """
    The timestamp that indicates when the event notification was created, in RFC 3339 format.
    """

    data: typing_extensions.NotRequired[CustomAttributeEventDataParams]
    """
    The data associated with the event that triggered the event notification.
    """
