# This file was auto-generated by Fern from our API Definition.

import typing_extensions
import typing_extensions
import typing
from ..types.currency import Currency


class MoneyParams(typing_extensions.TypedDict):
    """
    Represents an amount of money. `Money` fields can be signed or unsigned.
    Fields that do not explicitly define whether they are signed or unsigned are
    considered unsigned and can only hold positive amounts. For signed fields, the
    sign of the value indicates the purpose of the money transfer. See
    [Working with Monetary Amounts](https://developer.squareup.com/docs/build-basics/working-with-monetary-amounts)
    for more information.
    """

    amount: typing_extensions.NotRequired[typing.Optional[int]]
    """
    The amount of money, in the smallest denomination of the currency
    indicated by `currency`. For example, when `currency` is `USD`, `amount` is
    in cents. Monetary amounts can be positive or negative. See the specific
    field description to determine the meaning of the sign in a particular case.
    """

    currency: typing_extensions.NotRequired[Currency]
    """
    The type of currency, in __ISO 4217 format__. For example, the currency
    code for US dollars is `USD`.
    
    See [Currency](entity:Currency) for possible values.
    See [Currency](#type-currency) for possible values
    """
