# This file was auto-generated by Fern from our API Definition.

import typing_extensions
import typing_extensions
import typing
from .order_created_event_data import OrderCreatedEventDataParams


class OrderCreatedEventParams(typing_extensions.TypedDict):
    """
    Published when an [Order](entity:Order) is created. This event is
    triggered only by the [CreateOrder](api-endpoint:Orders-CreateOrder) endpoint call.

    Creating an order in the Point of Sale app will **not** publish this event.
    """

    merchant_id: typing_extensions.NotRequired[typing.Optional[str]]
    """
    The ID of the target merchant associated with the event.
    """

    type: typing_extensions.NotRequired[typing.Optional[str]]
    """
    The type of event this represents, `"order.created"`.
    """

    event_id: typing_extensions.NotRequired[typing.Optional[str]]
    """
    A unique ID for the event.
    """

    created_at: typing_extensions.NotRequired[str]
    """
    Timestamp of when the event was created, in RFC 3339 format.
    """

    data: typing_extensions.NotRequired[OrderCreatedEventDataParams]
    """
    Data associated with the event.
    """
