# This file was auto-generated by Fern from our API Definition.

import typing_extensions
import typing_extensions
from .measurement_unit import MeasurementUnitParams
import typing


class OrderQuantityUnitParams(typing_extensions.TypedDict):
    """
    Contains the measurement unit for a quantity and a precision that
    specifies the number of digits after the decimal point for decimal quantities.
    """

    measurement_unit: typing_extensions.NotRequired[MeasurementUnitParams]
    """
    A [MeasurementUnit](entity:MeasurementUnit) that represents the
    unit of measure for the quantity.
    """

    precision: typing_extensions.NotRequired[typing.Optional[int]]
    """
    For non-integer quantities, represents the number of digits after the decimal point that are
    recorded for this quantity.
    
    For example, a precision of 1 allows quantities such as `"1.0"` and `"1.1"`, but not `"1.01"`.
    
    Min: 0. Max: 5.
    """

    catalog_object_id: typing_extensions.NotRequired[typing.Optional[str]]
    """
    The catalog object ID referencing the
    [CatalogMeasurementUnit](entity:CatalogMeasurementUnit).
    
    This field is set when this is a catalog-backed measurement unit.
    """

    catalog_version: typing_extensions.NotRequired[typing.Optional[int]]
    """
    The version of the catalog object that this measurement unit references.
    
    This field is set when this is a catalog-backed measurement unit.
    """
