# This file was auto-generated by Fern from our API Definition.

import typing_extensions
import typing_extensions
import typing
from .order_updated_event_data import OrderUpdatedEventDataParams


class OrderUpdatedEventParams(typing_extensions.TypedDict):
    """
    Published when an [Order](entity:Order) is updated. This
    event is triggered by the [UpdateOrder](api-endpoint:Orders-UpdateOrder)
    endpoint call, Order Manager, or the Square Dashboard.
    """

    merchant_id: typing_extensions.NotRequired[typing.Optional[str]]
    """
    The ID of the target merchant associated with the event.
    """

    type: typing_extensions.NotRequired[typing.Optional[str]]
    """
    The type of event this represents, `"order.updated"`.
    """

    event_id: typing_extensions.NotRequired[typing.Optional[str]]
    """
    A unique ID for the event.
    """

    created_at: typing_extensions.NotRequired[str]
    """
    Timestamp of when the event was created, in RFC 3339 format.
    """

    data: typing_extensions.NotRequired[OrderUpdatedEventDataParams]
    """
    Data associated with the event.
    """
