# This file was auto-generated by Fern from our API Definition.

import typing_extensions
import typing_extensions
from .scheduled_shift_details import ScheduledShiftDetailsParams


class ScheduledShiftParams(typing_extensions.TypedDict):
    """
    Represents a specific time slot in a work schedule. This object is used to manage the
    lifecycle of a scheduled shift from the draft to published state. A scheduled shift contains
    the latest draft shift details and current published shift details.
    """

    id: typing_extensions.NotRequired[str]
    """
    **Read only** The Square-issued ID of the scheduled shift.
    """

    draft_shift_details: typing_extensions.NotRequired[ScheduledShiftDetailsParams]
    """
    The latest draft shift details for the scheduled shift. Draft shift details are used to
    stage and manage shifts before publishing. This field is always present.
    """

    published_shift_details: typing_extensions.NotRequired[ScheduledShiftDetailsParams]
    """
    The current published (public) shift details for the scheduled shift. This field is
    present only if the shift was published.
    """

    version: typing_extensions.NotRequired[int]
    """
    **Read only** The current version of the scheduled shift, which is incremented with each update.
    This field is used for [optimistic concurrency](https://developer.squareup.com/docs/build-basics/common-api-patterns/optimistic-concurrency)
    control to ensure that requests don't overwrite data from another request.
    """

    created_at: typing_extensions.NotRequired[str]
    """
    The timestamp of when the scheduled shift was created, in RFC 3339 format presented as UTC.
    """

    updated_at: typing_extensions.NotRequired[str]
    """
    The timestamp of when the scheduled shift was last updated, in RFC 3339 format presented as UTC.
    """
