# This file was auto-generated by Fern from our API Definition.

import typing_extensions
import typing_extensions
import typing
from .error import ErrorParams
from .customer import CustomerParams


class SearchCustomersResponseParams(typing_extensions.TypedDict):
    """
    Defines the fields that are included in the response body of
    a request to the `SearchCustomers` endpoint.

    Either `errors` or `customers` is present in a given response (never both).
    """

    errors: typing_extensions.NotRequired[typing.Sequence[ErrorParams]]
    """
    Any errors that occurred during the request.
    """

    customers: typing_extensions.NotRequired[typing.Sequence[CustomerParams]]
    """
    The customer profiles that match the search query. If any search condition is not met, the result is an empty object (`{}`).
    Only customer profiles with public information (`given_name`, `family_name`, `company_name`, `email_address`, or `phone_number`)
    are included in the response.
    """

    cursor: typing_extensions.NotRequired[str]
    """
    A pagination cursor that can be used during subsequent calls
    to `SearchCustomers` to retrieve the next set of results associated
    with the original query. Pagination cursors are only present when
    a request succeeds and additional results are available.
    
    For more information, see [Pagination](https://developer.squareup.com/docs/build-basics/common-api-patterns/pagination).
    """

    count: typing_extensions.NotRequired[int]
    """
    The total count of customers associated with the Square account that match the search query. Only customer profiles with
    public information (`given_name`, `family_name`, `company_name`, `email_address`, or `phone_number`) are counted. This field is
    present only if `count` is set to `true` in the request.
    """
