# This file was auto-generated by Fern from our API Definition.

import typing_extensions
import typing_extensions
import typing
from ..types.shift_filter_status import ShiftFilterStatus
from .time_range import TimeRangeParams
from .shift_workday import ShiftWorkdayParams


class ShiftFilterParams(typing_extensions.TypedDict):
    """
    Defines a filter used in a search for `Shift` records. `AND` logic is
    used by Square's servers to apply each filter property specified.

    Deprecated at Square API version 2025-05-21. See the [migration notes](https://developer.squareup.com/docs/labor-api/what-it-does#migration-notes).
    """

    location_ids: typing_extensions.NotRequired[typing.Optional[typing.Sequence[str]]]
    """
    Fetch shifts for the specified location.
    """

    employee_ids: typing_extensions.NotRequired[typing.Optional[typing.Sequence[str]]]
    """
    Fetch shifts for the specified employees. DEPRECATED at version 2020-08-26. Use `team_member_ids` instead.
    """

    status: typing_extensions.NotRequired[ShiftFilterStatus]
    """
    Fetch a `Shift` instance by `Shift.status`.
    See [ShiftFilterStatus](#type-shiftfilterstatus) for possible values
    """

    start: typing_extensions.NotRequired[TimeRangeParams]
    """
    Fetch `Shift` instances that start in the time range - Inclusive.
    """

    end: typing_extensions.NotRequired[TimeRangeParams]
    """
    Fetch the `Shift` instances that end in the time range - Inclusive.
    """

    workday: typing_extensions.NotRequired[ShiftWorkdayParams]
    """
    Fetch the `Shift` instances based on the workday date range.
    """

    team_member_ids: typing_extensions.NotRequired[typing.Optional[typing.Sequence[str]]]
    """
    Fetch shifts for the specified team members. Replaced `employee_ids` at version "2020-08-26".
    """
