# This file was auto-generated by Fern from our API Definition.

import typing_extensions
import typing_extensions
from .date_range import DateRangeParams
from ..types.shift_workday_matcher import ShiftWorkdayMatcher
import typing


class ShiftWorkdayParams(typing_extensions.TypedDict):
    """
    A `Shift` search query filter parameter that sets a range of days that
    a `Shift` must start or end in before passing the filter condition.

    Deprecated at Square API version 2025-05-21. See the [migration notes](https://developer.squareup.com/docs/labor-api/what-it-does#migration-notes).
    """

    date_range: typing_extensions.NotRequired[DateRangeParams]
    """
    Dates for fetching the shifts.
    """

    match_shifts_by: typing_extensions.NotRequired[ShiftWorkdayMatcher]
    """
    The strategy on which the dates are applied.
    See [ShiftWorkdayMatcher](#type-shiftworkdaymatcher) for possible values
    """

    default_timezone: typing_extensions.NotRequired[typing.Optional[str]]
    """
    Location-specific timezones convert workdays to datetime filters.
    Every location included in the query must have a timezone or this field
    must be provided as a fallback. Format: the IANA timezone database
    identifier for the relevant timezone.
    """
