# This file was auto-generated by Fern from our API Definition.

import typing_extensions
import typing_extensions
import typing
from .subscription_updated_event_data import SubscriptionUpdatedEventDataParams


class SubscriptionUpdatedEventParams(typing_extensions.TypedDict):
    """
    Published when a [Subscription](entity:Subscription) is updated.
    Typically the `subscription.status` is updated as subscriptions become active
    or cancelled.
    """

    merchant_id: typing_extensions.NotRequired[typing.Optional[str]]
    """
    The ID of the target merchant associated with the event.
    """

    type: typing_extensions.NotRequired[typing.Optional[str]]
    """
    The type of event this represents, `"subscription.updated"`.
    """

    event_id: typing_extensions.NotRequired[typing.Optional[str]]
    """
    A unique ID for the event.
    """

    created_at: typing_extensions.NotRequired[str]
    """
    Timestamp of when the event was created, in RFC 3339 format.
    """

    data: typing_extensions.NotRequired[SubscriptionUpdatedEventDataParams]
    """
    Data associated with the event.
    """
