# This file was auto-generated by Fern from our API Definition.

import typing_extensions
import typing_extensions
import typing
from .tender import TenderParams
from .refund import RefundParams
from ..types.transaction_product import TransactionProduct
from .address import AddressParams


class TransactionParams(typing_extensions.TypedDict):
    """
    Represents a transaction processed with Square, either with the
    Connect API or with Square Point of Sale.

    The `tenders` field of this object lists all methods of payment used to pay in
    the transaction.
    """

    id: typing_extensions.NotRequired[str]
    """
    The transaction's unique ID, issued by Square payments servers.
    """

    location_id: typing_extensions.NotRequired[typing.Optional[str]]
    """
    The ID of the transaction's associated location.
    """

    created_at: typing_extensions.NotRequired[str]
    """
    The timestamp for when the transaction was created, in RFC 3339 format.
    """

    tenders: typing_extensions.NotRequired[typing.Optional[typing.Sequence[TenderParams]]]
    """
    The tenders used to pay in the transaction.
    """

    refunds: typing_extensions.NotRequired[typing.Optional[typing.Sequence[RefundParams]]]
    """
    Refunds that have been applied to any tender in the transaction.
    """

    reference_id: typing_extensions.NotRequired[typing.Optional[str]]
    """
    If the transaction was created with the [Charge](api-endpoint:Transactions-Charge)
    endpoint, this value is the same as the value provided for the `reference_id`
    parameter in the request to that endpoint. Otherwise, it is not set.
    """

    product: typing_extensions.NotRequired[TransactionProduct]
    """
    The Square product that processed the transaction.
    See [TransactionProduct](#type-transactionproduct) for possible values
    """

    client_id: typing_extensions.NotRequired[typing.Optional[str]]
    """
    If the transaction was created in the Square Point of Sale app, this value
    is the ID generated for the transaction by Square Point of Sale.
    
    This ID has no relationship to the transaction's canonical `id`, which is
    generated by Square's backend servers. This value is generated for bookkeeping
    purposes, in case the transaction cannot immediately be completed (for example,
    if the transaction is processed in offline mode).
    
    It is not currently possible with the Connect API to perform a transaction
    lookup by this value.
    """

    shipping_address: typing_extensions.NotRequired[AddressParams]
    """
    The shipping address provided in the request, if any.
    """

    order_id: typing_extensions.NotRequired[typing.Optional[str]]
    """
    The order_id is an identifier for the order associated with this transaction, if any.
    """
