# This file was auto-generated by Fern from our API Definition.

from ..core.unchecked_base_model import UncheckedBaseModel
import pydantic
import typing
from .money import Money
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class AdditionalRecipient(UncheckedBaseModel):
    """
    Represents an additional recipient (other than the merchant) receiving a portion of this tender.
    """

    location_id: str = pydantic.Field()
    """
    The location ID for a recipient (other than the merchant) receiving a portion of this tender.
    """

    description: typing.Optional[str] = pydantic.Field(default=None)
    """
    The description of the additional recipient.
    """

    amount_money: Money = pydantic.Field()
    """
    The amount of money distributed to the recipient.
    """

    receivable_id: typing.Optional[str] = pydantic.Field(default=None)
    """
    The unique ID for the RETIRED `AdditionalRecipientReceivable` object. This field should be empty for any `AdditionalRecipient` objects created after the retirement.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
