# This file was auto-generated by Fern from our API Definition.

from ..core.unchecked_base_model import UncheckedBaseModel
import typing
import pydantic
from .bank_account_created_event_data import BankAccountCreatedEventData
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class BankAccountCreatedEvent(UncheckedBaseModel):
    """
    Published when you link an external bank account to a Square
    account in the Seller Dashboard. Square sets the initial status to
    `VERIFICATION_IN_PROGRESS` and publishes the event.
    """

    merchant_id: typing.Optional[str] = pydantic.Field(default=None)
    """
    The ID of the target merchant associated with the event.
    """

    location_id: typing.Optional[str] = pydantic.Field(default=None)
    """
    The ID of the target location associated with the event.
    """

    type: typing.Optional[str] = pydantic.Field(default=None)
    """
    The type of event this represents, `"bank_account.created"`.
    """

    event_id: typing.Optional[str] = pydantic.Field(default=None)
    """
    A unique ID for the event.
    """

    created_at: typing.Optional[str] = pydantic.Field(default=None)
    """
    Timestamp of when the event was created, in RFC 3339 format.
    """

    data: typing.Optional[BankAccountCreatedEventData] = pydantic.Field(default=None)
    """
    Data associated with the event.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
