# This file was auto-generated by Fern from our API Definition.

from ..core.unchecked_base_model import UncheckedBaseModel
import typing
import pydantic
from .bank_account_disabled_event_data import BankAccountDisabledEventData
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class BankAccountDisabledEvent(UncheckedBaseModel):
    """
    Published when Square sets the status of a
    [BankAccount](entity:BankAccount) to `DISABLED`.
    """

    merchant_id: typing.Optional[str] = pydantic.Field(default=None)
    """
    The ID of the target merchant associated with the event.
    """

    location_id: typing.Optional[str] = pydantic.Field(default=None)
    """
    The ID of the target location associated with the event.
    """

    type: typing.Optional[str] = pydantic.Field(default=None)
    """
    The type of event this represents, `"bank_account.disabled"`.
    """

    event_id: typing.Optional[str] = pydantic.Field(default=None)
    """
    A unique ID for the event.
    """

    created_at: typing.Optional[str] = pydantic.Field(default=None)
    """
    Timestamp of when the event was disabled, in RFC 3339 format.
    """

    data: typing.Optional[BankAccountDisabledEventData] = pydantic.Field(default=None)
    """
    Data associated with the event.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
