# This file was auto-generated by Fern from our API Definition.

from ..core.unchecked_base_model import UncheckedBaseModel
import typing
from .error import Error
import pydantic
from .get_vendor_response import GetVendorResponse
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class BatchGetVendorsResponse(UncheckedBaseModel):
    """
    Represents an output from a call to [BulkRetrieveVendors](api-endpoint:Vendors-BulkRetrieveVendors).
    """

    errors: typing.Optional[typing.List[Error]] = pydantic.Field(default=None)
    """
    Any errors that occurred during the request.
    """

    responses: typing.Optional[typing.Dict[str, GetVendorResponse]] = pydantic.Field(default=None)
    """
    The set of [RetrieveVendorResponse](entity:RetrieveVendorResponse) objects encapsulating successfully retrieved [Vendor](entity:Vendor)
    objects or error responses for failed attempts. The set is represented by 
    a collection of `Vendor`-ID/`Vendor`-object or `Vendor`-ID/error-object pairs.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
