# This file was auto-generated by Fern from our API Definition.

from ..core.unchecked_base_model import UncheckedBaseModel
import typing
from .booking_custom_attribute_delete_response import BookingCustomAttributeDeleteResponse
import pydantic
from .error import Error
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class BulkDeleteBookingCustomAttributesResponse(UncheckedBaseModel):
    """
    Represents a [BulkDeleteBookingCustomAttributes](api-endpoint:BookingCustomAttributes-BulkDeleteBookingCustomAttributes) response,
    which contains a map of responses that each corresponds to an individual delete request.
    """

    values: typing.Optional[typing.Dict[str, BookingCustomAttributeDeleteResponse]] = pydantic.Field(default=None)
    """
    A map of responses that correspond to individual delete requests. Each response has the
    same ID as the corresponding request and contains `booking_id` and  `errors` field.
    """

    errors: typing.Optional[typing.List[Error]] = pydantic.Field(default=None)
    """
    Any errors that occurred during the request.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
