# This file was auto-generated by Fern from our API Definition.

from ..core.unchecked_base_model import UncheckedBaseModel
import typing
import pydantic
from .custom_attribute import CustomAttribute
from .error import Error
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class BulkUpsertLocationCustomAttributesResponseLocationCustomAttributeUpsertResponse(UncheckedBaseModel):
    """
    Represents a response for an individual upsert request in a [BulkUpsertLocationCustomAttributes](api-endpoint:LocationCustomAttributes-BulkUpsertLocationCustomAttributes) operation.
    """

    location_id: typing.Optional[str] = pydantic.Field(default=None)
    """
    The ID of the location associated with the custom attribute.
    """

    custom_attribute: typing.Optional[CustomAttribute] = pydantic.Field(default=None)
    """
    The new or updated custom attribute.
    """

    errors: typing.Optional[typing.List[Error]] = pydantic.Field(default=None)
    """
    Any errors that occurred while processing the individual request.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
