# This file was auto-generated by Fern from our API Definition.

from ..core.unchecked_base_model import UncheckedBaseModel
import typing
import pydantic
from .catalog_custom_attribute_definition_type import CatalogCustomAttributeDefinitionType
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class CatalogCustomAttributeValue(UncheckedBaseModel):
    """
    An instance of a custom attribute. Custom attributes can be defined and
    added to `ITEM` and `ITEM_VARIATION` type catalog objects.
    [Read more about custom attributes](https://developer.squareup.com/docs/catalog-api/add-custom-attributes).
    """

    name: typing.Optional[str] = pydantic.Field(default=None)
    """
    The name of the custom attribute.
    """

    string_value: typing.Optional[str] = pydantic.Field(default=None)
    """
    The string value of the custom attribute.  Populated if `type` = `STRING`.
    """

    custom_attribute_definition_id: typing.Optional[str] = pydantic.Field(default=None)
    """
    The id of the [CatalogCustomAttributeDefinition](entity:CatalogCustomAttributeDefinition) this value belongs to.
    """

    type: typing.Optional[CatalogCustomAttributeDefinitionType] = pydantic.Field(default=None)
    """
    A copy of type from the associated `CatalogCustomAttributeDefinition`.
    See [CatalogCustomAttributeDefinitionType](#type-catalogcustomattributedefinitiontype) for possible values
    """

    number_value: typing.Optional[str] = pydantic.Field(default=None)
    """
    Populated if `type` = `NUMBER`. Contains a string
    representation of a decimal number, using a `.` as the decimal separator.
    """

    boolean_value: typing.Optional[bool] = pydantic.Field(default=None)
    """
    A `true` or `false` value. Populated if `type` = `BOOLEAN`.
    """

    selection_uid_values: typing.Optional[typing.List[str]] = pydantic.Field(default=None)
    """
    One or more choices from `allowed_selections`. Populated if `type` = `SELECTION`.
    """

    key: typing.Optional[str] = pydantic.Field(default=None)
    """
    If the associated `CatalogCustomAttributeDefinition` object is defined by another application, this key is prefixed by the defining application ID.
    For example, if the CatalogCustomAttributeDefinition has a key attribute of "cocoa_brand" and the defining application ID is "abcd1234", this key is "abcd1234:cocoa_brand"
    when the application making the request is different from the application defining the custom attribute definition. Otherwise, the key is simply "cocoa_brand".
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
