# This file was auto-generated by Fern from our API Definition.

from ..core.unchecked_base_model import UncheckedBaseModel
import typing
from .error import Error
import pydantic
from .card import Card
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class CreateCustomerCardResponse(UncheckedBaseModel):
    """
    Defines the fields that are included in the response body of
    a request to the `CreateCustomerCard` endpoint.

    Either `errors` or `card` is present in a given response (never both).
    """

    errors: typing.Optional[typing.List[Error]] = pydantic.Field(default=None)
    """
    Any errors that occurred during the request.
    """

    card: typing.Optional[Card] = pydantic.Field(default=None)
    """
    The created card on file.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
