# This file was auto-generated by Fern from our API Definition.

from ..core.unchecked_base_model import UncheckedBaseModel
import typing
from .error import Error
import pydantic
from .loyalty_promotion import LoyaltyPromotion
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class CreateLoyaltyPromotionResponse(UncheckedBaseModel):
    """
    Represents a [CreateLoyaltyPromotion](api-endpoint:Loyalty-CreateLoyaltyPromotion) response.
    Either `loyalty_promotion` or `errors` is present in the response.
    """

    errors: typing.Optional[typing.List[Error]] = pydantic.Field(default=None)
    """
    Any errors that occurred during the request.
    """

    loyalty_promotion: typing.Optional[LoyaltyPromotion] = pydantic.Field(default=None)
    """
    The new loyalty promotion.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
