# This file was auto-generated by Fern from our API Definition.

from ..core.unchecked_base_model import UncheckedBaseModel
import typing
from .order import Order
import pydantic
from .error import Error
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class CreateOrderResponse(UncheckedBaseModel):
    """
    Defines the fields that are included in the response body of
    a request to the `CreateOrder` endpoint.

    Either `errors` or `order` is present in a given response, but never both.
    """

    order: typing.Optional[Order] = pydantic.Field(default=None)
    """
    The newly created order.
    """

    errors: typing.Optional[typing.List[Error]] = pydantic.Field(default=None)
    """
    Any errors that occurred during the request.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
