# This file was auto-generated by Fern from our API Definition.

from ..core.unchecked_base_model import UncheckedBaseModel
import typing
from .error import Error
import pydantic
from .payment import Payment
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class CreatePaymentResponse(UncheckedBaseModel):
    """
    Defines the response returned by [CreatePayment](api-endpoint:Payments-CreatePayment).

    If there are errors processing the request, the `payment` field might not be
    present, or it might be present with a status of `FAILED`.
    """

    errors: typing.Optional[typing.List[Error]] = pydantic.Field(default=None)
    """
    Information about errors encountered during the request.
    """

    payment: typing.Optional[Payment] = pydantic.Field(default=None)
    """
    The newly created payment.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
