# This file was auto-generated by Fern from our API Definition.

from ..core.unchecked_base_model import UncheckedBaseModel
import typing
from .timecard import Timecard
import pydantic
from .error import Error
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class CreateTimecardResponse(UncheckedBaseModel):
    """
    The response to a request to create a `Timecard`. The response contains
    the created `Timecard` object and might contain a set of `Error` objects if
    the request resulted in errors.
    """

    timecard: typing.Optional[Timecard] = pydantic.Field(default=None)
    """
    The `Timecard` that was created on the request.
    """

    errors: typing.Optional[typing.List[Error]] = pydantic.Field(default=None)
    """
    Any errors that occurred during the request.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
