# This file was auto-generated by Fern from our API Definition.

from ..core.unchecked_base_model import UncheckedBaseModel
import typing
import pydantic
from .custom_attribute_definition_event_data_object import CustomAttributeDefinitionEventDataObject
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class CustomAttributeDefinitionEventData(UncheckedBaseModel):
    """
    Represents an object in the CustomAttributeDefinition event notification
    payload that contains the affected custom attribute definition.
    """

    type: typing.Optional[str] = pydantic.Field(default=None)
    """
    The type of the event data object. The value is `"custom_attribute_definition"`.
    """

    id: typing.Optional[str] = pydantic.Field(default=None)
    """
    The ID of the event data object.
    """

    object: typing.Optional[CustomAttributeDefinitionEventDataObject] = pydantic.Field(default=None)
    """
    An object containing the custom attribute definition.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
