# This file was auto-generated by Fern from our API Definition.

from ..core.unchecked_base_model import UncheckedBaseModel
import typing
import pydantic
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class CustomerCreatedEventEventContextMerge(UncheckedBaseModel):
    """
    Information about a merge operation, which creates a new customer using aggregated properties from two or more existing customers.
    """

    from_customer_ids: typing.Optional[typing.List[str]] = pydantic.Field(default=None)
    """
    The IDs of the existing customers that were merged and then deleted.
    """

    to_customer_id: typing.Optional[str] = pydantic.Field(default=None)
    """
    The ID of the new customer created by the merge.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
