# This file was auto-generated by Fern from our API Definition.

from ..core.unchecked_base_model import UncheckedBaseModel
import typing
import pydantic
from .customer_deleted_event_data import CustomerDeletedEventData
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class CustomerDeletedEvent(UncheckedBaseModel):
    """
    Published when a [customer](entity:Customer) is deleted.  For more information, see [Use Customer Webhooks](https://developer.squareup.com/docs/customers-api/use-the-api/customer-webhooks).

    The `customer` object in the event notification does not include the following fields: `group_ids` and `segment_ids`.
    """

    merchant_id: typing.Optional[str] = pydantic.Field(default=None)
    """
    The ID of the seller associated with the event.
    """

    type: typing.Optional[str] = pydantic.Field(default=None)
    """
    The type of event. For this object, the value is `customer.deleted`.
    """

    event_id: typing.Optional[str] = pydantic.Field(default=None)
    """
    The unique ID of the event, which is used for [idempotency support](https://developer.squareup.com/docs/webhooks/step4manage#webhooks-best-practices).
    """

    created_at: typing.Optional[str] = pydantic.Field(default=None)
    """
    The timestamp of when the event was created, in RFC 3339 format.
    """

    data: typing.Optional[CustomerDeletedEventData] = pydantic.Field(default=None)
    """
    The data associated with the event.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
