# This file was auto-generated by Fern from our API Definition.

from ..core.unchecked_base_model import UncheckedBaseModel
import typing
import pydantic
from .customer_deleted_event_object import CustomerDeletedEventObject
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class CustomerDeletedEventData(UncheckedBaseModel):
    """
    The data associated with the event.
    """

    type: typing.Optional[str] = pydantic.Field(default=None)
    """
    The type of object affected by the event. For this event, the value is `customer`.
    """

    id: typing.Optional[str] = pydantic.Field(default=None)
    """
    The ID of the deleted customer.
    """

    object: typing.Optional[CustomerDeletedEventObject] = pydantic.Field(default=None)
    """
    An object that contains the deleted customer.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
