# This file was auto-generated by Fern from our API Definition.

from ..core.unchecked_base_model import UncheckedBaseModel
import typing
import pydantic
from .device_code_paired_event_data import DeviceCodePairedEventData
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class DeviceCodePairedEvent(UncheckedBaseModel):
    """
    Published when a Square Terminal has been paired with a
    Terminal API client and the device_id of the paired Square Terminal is
    available.
    """

    merchant_id: typing.Optional[str] = pydantic.Field(default=None)
    """
    The ID of the target merchant associated with the event.
    """

    location_id: typing.Optional[str] = pydantic.Field(default=None)
    """
    The ID of the target location associated with the event.
    """

    type: typing.Optional[str] = pydantic.Field(default=None)
    """
    The type of event this represents, `"device.code.paired"`.
    """

    event_id: typing.Optional[str] = pydantic.Field(default=None)
    """
    A unique ID for the event.
    """

    created_at: typing.Optional[str] = pydantic.Field(default=None)
    """
    RFC 3339 timestamp of when the event was created.
    """

    data: typing.Optional[DeviceCodePairedEventData] = pydantic.Field(default=None)
    """
    Data associated with the event.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
