# This file was auto-generated by Fern from our API Definition.

from ..core.unchecked_base_model import UncheckedBaseModel
import typing
import pydantic
from .dispute_evidence_removed_event_data import DisputeEvidenceRemovedEventData
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class DisputeEvidenceRemovedEvent(UncheckedBaseModel):
    """
    Published when evidence is removed from a [Dispute](entity:Dispute)
    from the Disputes Dashboard in the Seller Dashboard, the Square Point of Sale app,
    or by calling [DeleteDisputeEvidence](api-endpoint:Disputes-DeleteDisputeEvidence).
    """

    merchant_id: typing.Optional[str] = pydantic.Field(default=None)
    """
    The ID of the target merchant associated with the event.
    """

    location_id: typing.Optional[str] = pydantic.Field(default=None)
    """
    The ID of the target location associated with the event.
    """

    type: typing.Optional[str] = pydantic.Field(default=None)
    """
    The type of event this represents.
    """

    event_id: typing.Optional[str] = pydantic.Field(default=None)
    """
    A unique ID for the event.
    """

    created_at: typing.Optional[str] = pydantic.Field(default=None)
    """
    Timestamp of when the event was created, in RFC 3339 format.
    """

    data: typing.Optional[DisputeEvidenceRemovedEventData] = pydantic.Field(default=None)
    """
    Data associated with the event.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
