# This file was auto-generated by Fern from our API Definition.

from ..core.unchecked_base_model import UncheckedBaseModel
import typing
from .error import Error
import pydantic
from .location import Location
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class GetLocationResponse(UncheckedBaseModel):
    """
    Defines the fields that the [RetrieveLocation](api-endpoint:Locations-RetrieveLocation)
    endpoint returns in a response.
    """

    errors: typing.Optional[typing.List[Error]] = pydantic.Field(default=None)
    """
    Information about errors encountered during the request.
    """

    location: typing.Optional[Location] = pydantic.Field(default=None)
    """
    The requested location.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
