# This file was auto-generated by Fern from our API Definition.

from ..core.unchecked_base_model import UncheckedBaseModel
import typing
from .gift_card import GiftCard
import pydantic
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class GiftCardCustomerLinkedEventObject(UncheckedBaseModel):
    """
    An object that contains the gift card and customer ID associated with a
    `gift_card.customer_linked` event.
    """

    gift_card: typing.Optional[GiftCard] = pydantic.Field(default=None)
    """
    The gift card with the updated `customer_ids` field.
    """

    linked_customer_id: typing.Optional[str] = pydantic.Field(default=None)
    """
    The ID of the linked [customer](entity:Customer).
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
