# This file was auto-generated by Fern from our API Definition.

from ..core.unchecked_base_model import UncheckedBaseModel
from .invoice_sort_field import InvoiceSortField
import pydantic
import typing
from .sort_order import SortOrder
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class InvoiceSort(UncheckedBaseModel):
    """
    Identifies the sort field and sort order.
    """

    field: InvoiceSortField = pydantic.Field(default="INVOICE_SORT_DATE")
    """
    The field to use for sorting.
    See [InvoiceSortField](#type-invoicesortfield) for possible values
    """

    order: typing.Optional[SortOrder] = pydantic.Field(default=None)
    """
    The order to use for sorting the results.
    See [SortOrder](#type-sortorder) for possible values
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
