# This file was auto-generated by Fern from our API Definition.

from ..core.unchecked_base_model import UncheckedBaseModel
import typing
import pydantic
from .labor_shift_updated_event_data import LaborShiftUpdatedEventData
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class LaborShiftUpdatedEvent(UncheckedBaseModel):
    """
    Published when a [Shift](entity:Shift) is updated.

    Deprecated at Square API version 2025-05-21. Replaced by `labor.timecard.updated`.
    """

    merchant_id: typing.Optional[str] = pydantic.Field(default=None)
    """
    The ID of the merchant associated with the event.
    """

    type: typing.Optional[str] = pydantic.Field(default=None)
    """
    The type of event. For this event, the value is `labor.shift.updated`.
    """

    event_id: typing.Optional[str] = pydantic.Field(default=None)
    """
    The unique ID for the event.
    """

    created_at: typing.Optional[str] = pydantic.Field(default=None)
    """
    The timestamp of when the event was created, in RFC 3339 format.
    """

    data: typing.Optional[LaborShiftUpdatedEventData] = pydantic.Field(default=None)
    """
    The data associated with the event.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
