# This file was auto-generated by Fern from our API Definition.

from ..core.unchecked_base_model import UncheckedBaseModel
import typing
import pydantic
from .labor_timecard_created_event_data import LaborTimecardCreatedEventData
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class LaborTimecardCreatedEvent(UncheckedBaseModel):
    """
    Published when a worker starts a [Timecard](entity:Timecard).
    """

    merchant_id: typing.Optional[str] = pydantic.Field(default=None)
    """
    The ID of the target merchant associated with the event.
    """

    type: typing.Optional[str] = pydantic.Field(default=None)
    """
    The type of event. For this event, the value is `labor.timecard.created`.
    """

    event_id: typing.Optional[str] = pydantic.Field(default=None)
    """
    The unique ID for the event.
    """

    created_at: typing.Optional[str] = pydantic.Field(default=None)
    """
    The timestamp of when the event was created, in RFC 3339 format.
    """

    data: typing.Optional[LaborTimecardCreatedEventData] = pydantic.Field(default=None)
    """
    The data associated with the event.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
