# This file was auto-generated by Fern from our API Definition.

from ..core.unchecked_base_model import UncheckedBaseModel
import typing
from .error import Error
import pydantic
from .location import Location
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class ListLocationsResponse(UncheckedBaseModel):
    """
    Defines the fields that are included in the response body of a request
    to the [ListLocations](api-endpoint:Locations-ListLocations) endpoint.

    Either `errors` or `locations` is present in a given response (never both).
    """

    errors: typing.Optional[typing.List[Error]] = pydantic.Field(default=None)
    """
    Any errors that occurred during the request.
    """

    locations: typing.Optional[typing.List[Location]] = pydantic.Field(default=None)
    """
    The business locations.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
