# This file was auto-generated by Fern from our API Definition.

from ..core.unchecked_base_model import UncheckedBaseModel
import typing
from .error import Error
import pydantic
from .merchant import Merchant
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class ListMerchantsResponse(UncheckedBaseModel):
    """
    The response object returned by the [ListMerchant](api-endpoint:Merchants-ListMerchants) endpoint.
    """

    errors: typing.Optional[typing.List[Error]] = pydantic.Field(default=None)
    """
    Information on errors encountered during the request.
    """

    merchant: typing.Optional[typing.List[Merchant]] = pydantic.Field(default=None)
    """
    The requested `Merchant` entities.
    """

    cursor: typing.Optional[int] = pydantic.Field(default=None)
    """
    If the  response is truncated, the cursor to use in next  request to fetch next set of objects.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
