# This file was auto-generated by Fern from our API Definition.

from ..core.unchecked_base_model import UncheckedBaseModel
import typing
from .custom_attribute_definition import CustomAttributeDefinition
import pydantic
from .error import Error
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class ListOrderCustomAttributeDefinitionsResponse(UncheckedBaseModel):
    """
    Represents a response from listing order custom attribute definitions.
    """

    custom_attribute_definitions: typing.List[CustomAttributeDefinition] = pydantic.Field()
    """
    The retrieved custom attribute definitions. If no custom attribute definitions are found, Square returns an empty object (`{}`).
    """

    cursor: typing.Optional[str] = pydantic.Field(default=None)
    """
    The cursor to provide in your next call to this endpoint to retrieve the next page of results for your original request. 
    This field is present only if the request succeeded and additional results are available.
    For more information, see [Pagination](https://developer.squareup.com/docs/working-with-apis/pagination).
    """

    errors: typing.Optional[typing.List[Error]] = pydantic.Field(default=None)
    """
    Any errors that occurred during the request.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
