# This file was auto-generated by Fern from our API Definition.

from ..core.unchecked_base_model import UncheckedBaseModel
import typing
from .team_member_booking_profile import TeamMemberBookingProfile
import pydantic
from .error import Error
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class ListTeamMemberBookingProfilesResponse(UncheckedBaseModel):
    team_member_booking_profiles: typing.Optional[typing.List[TeamMemberBookingProfile]] = pydantic.Field(default=None)
    """
    The list of team member booking profiles. The results are returned in the ascending order of the time
    when the team member booking profiles were last updated. Multiple booking profiles updated at the same time
    are further sorted in the ascending order of their IDs.
    """

    cursor: typing.Optional[str] = pydantic.Field(default=None)
    """
    The pagination cursor to be used in the subsequent request to get the next page of the results. Stop retrieving the next page of the results when the cursor is not set.
    """

    errors: typing.Optional[typing.List[Error]] = pydantic.Field(default=None)
    """
    Errors that occurred during the request.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
