# This file was auto-generated by Fern from our API Definition.

from ..core.unchecked_base_model import UncheckedBaseModel
import typing
import pydantic
from .loyalty_account_created_event_data import LoyaltyAccountCreatedEventData
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class LoyaltyAccountCreatedEvent(UncheckedBaseModel):
    """
    Published when a [loyalty account](entity:LoyaltyAccount) is created.
    """

    merchant_id: typing.Optional[str] = pydantic.Field(default=None)
    """
    The ID of the Square seller associated with the event.
    """

    type: typing.Optional[str] = pydantic.Field(default=None)
    """
    The type of event. For this event, the value is `loyalty.account.created`.
    """

    event_id: typing.Optional[str] = pydantic.Field(default=None)
    """
    The unique ID for the event, which is used for
    [idempotency support](https://developer.squareup.com/docs/webhooks/step4manage#webhooks-best-practices).
    """

    created_at: typing.Optional[str] = pydantic.Field(default=None)
    """
    The timestamp of when the event was created, in RFC 3339 format.
    """

    data: typing.Optional[LoyaltyAccountCreatedEventData] = pydantic.Field(default=None)
    """
    The data associated with the event.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
