# This file was auto-generated by Fern from our API Definition.

from ..core.unchecked_base_model import UncheckedBaseModel
import typing
import pydantic
from .loyalty_account_deleted_event_object import LoyaltyAccountDeletedEventObject
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class LoyaltyAccountDeletedEventData(UncheckedBaseModel):
    """
    The data associated with a `loyalty.account.deleted` event.
    """

    type: typing.Optional[str] = pydantic.Field(default=None)
    """
    The type of object affected by the event. For this event, the value is `loyalty_account`.
    """

    id: typing.Optional[str] = pydantic.Field(default=None)
    """
    The ID of the affected loyalty account.
    """

    object: typing.Optional[LoyaltyAccountDeletedEventObject] = pydantic.Field(default=None)
    """
    An object that contains the loyalty account that was deleted.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
