# This file was auto-generated by Fern from our API Definition.

from ..core.unchecked_base_model import UncheckedBaseModel
import typing
import pydantic
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class LoyaltyEventAdjustPoints(UncheckedBaseModel):
    """
    Provides metadata when the event `type` is `ADJUST_POINTS`.
    """

    loyalty_program_id: typing.Optional[str] = pydantic.Field(default=None)
    """
    The Square-assigned ID of the [loyalty program](entity:LoyaltyProgram).
    """

    points: int = pydantic.Field()
    """
    The number of points added or removed.
    """

    reason: typing.Optional[str] = pydantic.Field(default=None)
    """
    The reason for the adjustment of points.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
