# This file was auto-generated by Fern from our API Definition.

from ..core.unchecked_base_model import UncheckedBaseModel
import typing
import pydantic
from .loyalty_program_created_event_object import LoyaltyProgramCreatedEventObject
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class LoyaltyProgramCreatedEventData(UncheckedBaseModel):
    """
    The data associated with a `loyalty.program.created` event.
    """

    type: typing.Optional[str] = pydantic.Field(default=None)
    """
    The type of object affected by the event. For this event, the value is `loyalty_program`.
    """

    id: typing.Optional[str] = pydantic.Field(default=None)
    """
    The ID of the created loyalty program.
    """

    object: typing.Optional[LoyaltyProgramCreatedEventObject] = pydantic.Field(default=None)
    """
    An object that contains the loyalty program that was created.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
