# This file was auto-generated by Fern from our API Definition.

from ..core.unchecked_base_model import UncheckedBaseModel
import typing
import pydantic
from .loyalty_program_updated_event_object import LoyaltyProgramUpdatedEventObject
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class LoyaltyProgramUpdatedEventData(UncheckedBaseModel):
    """
    The data associated with a `loyalty.program.updated` event.
    """

    type: typing.Optional[str] = pydantic.Field(default=None)
    """
    The type of object affected by the event. For this event, the value is `loyalty_program`.
    """

    id: typing.Optional[str] = pydantic.Field(default=None)
    """
    The ID of the affected loyalty program.
    """

    object: typing.Optional[LoyaltyProgramUpdatedEventObject] = pydantic.Field(default=None)
    """
    An object that contains the loyalty program that was updated.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
