# This file was auto-generated by Fern from our API Definition.

from ..core.unchecked_base_model import UncheckedBaseModel
import typing
import pydantic
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class OrderLineItemPricingBlocklistsBlockedDiscount(UncheckedBaseModel):
    """
    A discount to block from applying to a line item. The discount must be
    identified by either `discount_uid` or `discount_catalog_object_id`, but not both.
    """

    uid: typing.Optional[str] = pydantic.Field(default=None)
    """
    A unique ID of the `BlockedDiscount` within the order.
    """

    discount_uid: typing.Optional[str] = pydantic.Field(default=None)
    """
    The `uid` of the discount that should be blocked. Use this field to block
    ad hoc discounts. For catalog discounts, use the `discount_catalog_object_id` field.
    """

    discount_catalog_object_id: typing.Optional[str] = pydantic.Field(default=None)
    """
    The `catalog_object_id` of the discount that should be blocked.
    Use this field to block catalog discounts. For ad hoc discounts, use the
    `discount_uid` field.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
