# This file was auto-generated by Fern from our API Definition.

from ..core.unchecked_base_model import UncheckedBaseModel
import typing
from .error import Error
import pydantic
from .order import Order
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class PayOrderResponse(UncheckedBaseModel):
    """
    Defines the fields that are included in the response body of a request to the
    [PayOrder](api-endpoint:Orders-PayOrder) endpoint.
    """

    errors: typing.Optional[typing.List[Error]] = pydantic.Field(default=None)
    """
    Any errors that occurred during the request.
    """

    order: typing.Optional[Order] = pydantic.Field(default=None)
    """
    The paid, updated [order](entity:Order).
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
