# This file was auto-generated by Fern from our API Definition.

from ..core.unchecked_base_model import UncheckedBaseModel
import typing
import pydantic
from .address import Address
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class PrePopulatedData(UncheckedBaseModel):
    """
    Describes buyer data to prepopulate in the payment form.
    For more information,
    see [Optional Checkout Configurations](https://developer.squareup.com/docs/checkout-api/optional-checkout-configurations).
    """

    buyer_email: typing.Optional[str] = pydantic.Field(default=None)
    """
    The buyer email to prepopulate in the payment form.
    """

    buyer_phone_number: typing.Optional[str] = pydantic.Field(default=None)
    """
    The buyer phone number to prepopulate in the payment form.
    """

    buyer_address: typing.Optional[Address] = pydantic.Field(default=None)
    """
    The buyer address to prepopulate in the payment form.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
