# This file was auto-generated by Fern from our API Definition.

from ..core.unchecked_base_model import UncheckedBaseModel
import pydantic
from ..core.pydantic_utilities import IS_PYDANTIC_V2
import typing


class QrCodeOptions(UncheckedBaseModel):
    """
    Fields to describe the action that displays QR-Codes.
    """

    title: str = pydantic.Field()
    """
    The title text to display in the QR code flow on the Terminal.
    """

    body: str = pydantic.Field()
    """
    The body text to display in the QR code flow on the Terminal.
    """

    barcode_contents: str = pydantic.Field()
    """
    The text representation of the data to show in the QR code
    as UTF8-encoded data.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
