# This file was auto-generated by Fern from our API Definition.

from ..core.unchecked_base_model import UncheckedBaseModel
import typing
from .error import Error
import pydantic
from .payment_refund import PaymentRefund
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class RefundPaymentResponse(UncheckedBaseModel):
    """
    Defines the response returned by
    [RefundPayment](api-endpoint:Refunds-RefundPayment).

    If there are errors processing the request, the `refund` field might not be
    present, or it might be present with a status of `FAILED`.
    """

    errors: typing.Optional[typing.List[Error]] = pydantic.Field(default=None)
    """
    Information about errors encountered during the request.
    """

    refund: typing.Optional[PaymentRefund] = pydantic.Field(default=None)
    """
    The successfully created `PaymentRefund`.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
