# This file was auto-generated by Fern from our API Definition.

from ..core.unchecked_base_model import UncheckedBaseModel
import typing
from .shift import Shift
import pydantic
from .error import Error
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class SearchShiftsResponse(UncheckedBaseModel):
    """
    The response to a request for `Shift` objects. The response contains
    the requested `Shift` objects and might contain a set of `Error` objects if
    the request resulted in errors.
    """

    shifts: typing.Optional[typing.List[Shift]] = pydantic.Field(default=None)
    """
    Shifts.
    """

    cursor: typing.Optional[str] = pydantic.Field(default=None)
    """
    An opaque cursor for fetching the next page.
    """

    errors: typing.Optional[typing.List[Error]] = pydantic.Field(default=None)
    """
    Any errors that occurred during the request.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
