# This file was auto-generated by Fern from our API Definition.

from ..core.unchecked_base_model import UncheckedBaseModel
import typing
from .money import Money
import pydantic
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class TenderCashDetails(UncheckedBaseModel):
    """
    Represents the details of a tender with `type` `CASH`.
    """

    buyer_tendered_money: typing.Optional[Money] = pydantic.Field(default=None)
    """
    The total amount of cash provided by the buyer, before change is given.
    """

    change_back_money: typing.Optional[Money] = pydantic.Field(default=None)
    """
    The amount of change returned to the buyer.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
