# This file was auto-generated by Fern from our API Definition.

from ..core.unchecked_base_model import UncheckedBaseModel
import typing
import pydantic
from .time_range import TimeRange
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class TerminalCheckoutQueryFilter(UncheckedBaseModel):
    device_id: typing.Optional[str] = pydantic.Field(default=None)
    """
    The `TerminalCheckout` objects associated with a specific device. If no device is specified, then all
    `TerminalCheckout` objects for the merchant are displayed.
    """

    created_at: typing.Optional[TimeRange] = pydantic.Field(default=None)
    """
    The time range for the beginning of the reporting period, which is inclusive.
    Default value: The current time minus one day.
    Note that `TerminalCheckout`s are available for 30 days after creation.
    """

    status: typing.Optional[str] = pydantic.Field(default=None)
    """
    Filtered results with the desired status of the `TerminalCheckout`.
    Options: `PENDING`, `IN_PROGRESS`, `CANCEL_REQUESTED`, `CANCELED`, `COMPLETED`
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
