# This file was auto-generated by Fern from our API Definition.

from ..core.unchecked_base_model import UncheckedBaseModel
import typing
from .error import Error
import pydantic
from .subscription_test_result import SubscriptionTestResult
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class TestWebhookSubscriptionResponse(UncheckedBaseModel):
    """
    Defines the fields that are included in the response body of
    a request to the [TestWebhookSubscription](api-endpoint:WebhookSubscriptions-TestWebhookSubscription) endpoint.

    Note: If there are errors processing the request, the [SubscriptionTestResult](entity:SubscriptionTestResult) field is not
    present.
    """

    errors: typing.Optional[typing.List[Error]] = pydantic.Field(default=None)
    """
    Information on errors encountered during the request.
    """

    subscription_test_result: typing.Optional[SubscriptionTestResult] = pydantic.Field(default=None)
    """
    The [SubscriptionTestResult](entity:SubscriptionTestResult).
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
