# This file was auto-generated by Fern from our API Definition.

from ..core.unchecked_base_model import UncheckedBaseModel
import typing
from .job import Job
import pydantic
from .error import Error
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class UpdateJobResponse(UncheckedBaseModel):
    """
    Represents an [UpdateJob](api-endpoint:Team-UpdateJob) response. Either `job` or `errors`
    is present in the response.
    """

    job: typing.Optional[Job] = pydantic.Field(default=None)
    """
    The updated job.
    """

    errors: typing.Optional[typing.List[Error]] = pydantic.Field(default=None)
    """
    The errors that occurred during the request.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
