# This file was auto-generated by Fern from our API Definition.

from ..core.unchecked_base_model import UncheckedBaseModel
import typing
from .error import Error
import pydantic
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class UpdateWebhookSubscriptionSignatureKeyResponse(UncheckedBaseModel):
    """
    Defines the fields that are included in the response body of
    a request to the [UpdateWebhookSubscriptionSignatureKey](api-endpoint:WebhookSubscriptions-UpdateWebhookSubscriptionSignatureKey) endpoint.

    Note: If there are errors processing the request, the [Subscription](entity:WebhookSubscription) is not
    present.
    """

    errors: typing.Optional[typing.List[Error]] = pydantic.Field(default=None)
    """
    Information on errors encountered during the request.
    """

    signature_key: typing.Optional[str] = pydantic.Field(default=None)
    """
    The new Square-generated signature key used to validate the origin of the webhook event.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
