# This file was auto-generated by Fern from our API Definition.

from ..core.unchecked_base_model import UncheckedBaseModel
import typing
from .error import Error
import pydantic
from .snippet import Snippet
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class UpsertSnippetResponse(UncheckedBaseModel):
    """
    Represents an `UpsertSnippet` response. The response can include either `snippet` or `errors`.
    """

    errors: typing.Optional[typing.List[Error]] = pydantic.Field(default=None)
    """
    Any errors that occurred during the request.
    """

    snippet: typing.Optional[Snippet] = pydantic.Field(default=None)
    """
    The new or updated snippet.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
